--[[
	JewelTips 0.5.5
]]--

local TipHooker = AceLibrary("TipHooker-1.0")

--Create Jeweltips frame
local JewelTips = CreateFrame("Frame")
JewelTips:SetScript("OnEvent", function(JewelTips, event, ...)
  if (event == "ADDON_LOADED" and arg1 == "JewelTips") then
    --Hook GameTooltip
    TipHooker:Hook(JewelTips.Main, "item")
    JewelTips:UnregisterEvent("ADDON_LOADED")
  end
end)
JewelTips:RegisterEvent("ADDON_LOADED")

--Localize functions
local tonumber, GetItemInfo, GetItemGem, select = tonumber, GetItemInfo, GetItemGem, select
local strgsub = string.gsub
local strmatch = string.match
--Localize tooltips
local ItemRefTooltip, GameTooltip = ItemRefTooltip, GameTooltip

JewelTips.TOOLTIP_ANCHOR = "ANCHOR_BOTTOMLEFT"
JewelTips.BUTTON_SIZE = 30
JewelTips.UNCACHED_MESSAGE = "|cffffffffUncached Jewel. Please close and reopen tooltip.|r"
JewelTips.QUESTIONMARK_ICON = "Interface\\Icons\\INV_Misc_QuestionMark"
JewelTips.Jewels = {
--		[] = "0",
  [15] = 304, --Light Armor Kit
  [16] = 2313, --Medium Armor Kit
  [17] = 4265, --Heavy Armor Kit
  [18] = 8173, --Thick Armor Kit
  [30] = 4405, --Crude Scope
  [32] = 4406, --Standard Scope
  [33] = 4407, --Accurate Scope
  [34] = 6043, --Iron Counterweight
  [37] = 6041, --Steel Weapon Chain
  [41] = "Enchant Bracer - Minor Health:7418",
  [66] = "Enchant Bracer - Minor Stamina:7457", --+1 Stamina
  [368] = "Enchant Cloak - Greater Agility:34004",
  [369] = "Enchant Bracer - Major Intellect:34001",
  [464] = 7969, --Mithril Spurs
  [663] = 10546, --Deadly Scope
  [664] = 10548, --Sniper Scope
  [684] = "Enchant Gloves - Major Strength:33995",
  [723] = "Enchant 2H Weapon - Lesser Intellect:7793", --+3 Intellect
  [744] = "Enchant Cloak - Lesser Protection:13421",
  [783] = "Enchant Cloak - Minor Protection:7771", --+10 Armor
  [803] = "Enchant Weapon - Fiery Weapon:13898",
  [849] = "Enchant Cloak - Lesser Agility:13882",
  [851] = "Enchant Boots - Spirit:20024",
  [852] = "Enchant Boots - Stamina:13836",
  [884] = "Enchant Cloak - Greater Defense:13746",
  [903] = "Enchant Cloak - Resistance:13794",
  [904] = "Enchant Gloves - Agility:13815",
  [905] = "Enchant Bracer - Intellect:13822",
  [911] = "Enchant Boots - Minor Speed:13890",
  [913] = "Enchant Chest - Superior Mana:13917",
  [923] = "Enchant Bracer - Deflection:13931", --+5 Defense Rating
  [928] = "Enchant Chest - Stats:13941",
  [929] = "Enchant Shield - Greater Stamina:20017",
  [963] = "Enchant 2H Weapon - Greater Impact:13937",
  [1071] = "Enchant Shield - Major Stamina:34009",
  [1144] = "Enchant Chest - Major Spirit:33990", -- +15 Spirit
  [1483] = 11622, --Lesser Arcanum of Rumination
  [1503] = 11642, --Lesser Arcanum of Constitution
  [1504] = 11643, --Lesser Arcanum of Tenacity
  [1505] = 11644, --Lesser Arcanum of Resilience
  [1506] = 11645, --Lesser Arcanum of Voracity
  [1507] = 11646, --Lesser Arcanum of Voracity
  [1508] = 11647, --Lesser Arcanum of Voracity
  [1509] = 11648, --Lesser Arcanum of Voracity
  [1510] = 11649, --Lesser Arcanum of Voracity
  [1593] = "Enchant Bracer - Assault:34002",  -- +24 Attack Power
  [1594] = "Enchant Gloves - Assault:33996",  -- +26 Attack Power
  [1704] = 12645, --Thorium Spike (20-30)
  [1843] = 15564, --Rugged Armor Kit
  [1883] = "Enchant Bracer - Greater Intellect:20008",
  [1884] = "Enchant Bracer - Superior Spirit:20009",
  [1886] = "Enchant Bracer - Superior Stamina:20011", -- +9 Stamina
  [1887] = "Enchant Gloves - Greater Agility:20012", -- +7 Agility
  [1888] = "Enchant Cloak - Greater Resistance:20014", --+5 All Resistances
  [1891] = "Enchant Bracer - Stats:27905",  --+4 All Stats
  [1892] = "Enchant Chest - Major Health:20026",  -- +100 Health
  [1894] = "Enchant Weapon - Icy Chill:20029", --Icy Weapon
  [1899] = "Enchant Weapon - Unholy Weapon:20033",  --Unholy Weapon
  [1900] = "Enchant Weapon - Crusader:20034", -- Crusader
  [2322] = "Enchant Gloves - Major Healing:33999",
  [2343] = "Enchant Weapon - Major Healing:34010",
  [2376] = "Enchant Chest - Restore Mana Prime:33991", -- changed?
  [2483] = 18169, --Flame Mantle of the Dawn
  [2484] = 18170, --Frost Mantle of the Dawn
  [2485] = 18171, --Arcane Mantle of the Dawn
  [2486] = 18172, --Nature Mantle of the Dawn
  [2487] = 18173, --Shadow Mantle of the Dawn
  [2488] = 18182, --Chromatic Mantle of the Dawn
  [2503] = 18251, --Core Armor Kit
  [2505] = "Enchant Weapon - Healing Power:22750", -- +55 Healing
  [2523] = 18283, --Biznicks 247x128 Accurascope
  [2543] = 18329, --Arcanum of Rapidity
  [2544] = 18330, --Arcanum of Focus
  [2545] = 18331, --Arcanum of Protection

  [2563] = "Enchant Weapon - Strength:23799", -- +15 Strength
  [2564] = "Enchant Weapon - Agility:23800", -- +15 Agility
  [2565] = "Enchant Bracer - Mana Regeneration:23801", -- Mana Regen 4 per 5 sec.
  [2566] = "Enchant Bracer - Healing Power:23802", -- +24 Healing
  [2567] = "Enchant Weapon - Mighty Spirit:23803", -- +20 Spirit
  [2568] = "Enchant Weapon - Mighty Intellect:23804", -- +22 Intellect

  [2583] = 19782, --Presence of Might
  [2584] = 19783, --Syncretist's Sigil
  [2585] = 19784, --Death's Embrace
  [2586] = 19785, --Falcon's Call
  [2587] = 19786, --Vodouisant's Vigilant Embrace
  [2588] = 19787, --Presence of Sight
  [2589] = 19788, --Hoodoo Hex
  [2590] = 19789, --Prophetic Aura
  [2591] = 19790, --Animist's Caress

  [2603] = 19971, --High Test Eternium Fishing Line
  [2604] = 20078,  --Zandalar Signet of Serenity
  [2605] = 20076,  --Zandalar Signet of Mojo
  [2606] = 20077,  --Zandalar Signet of Might

  [2613] = "Enchant Gloves - Threat:25072", --+2% Threat
  [2614] = "Enchant Gloves - Shadow Power:25073",
  [2615] = "Enchant Gloves - Frost Power:25074",
  [2616] = "Enchant Gloves - Fire Power:25078",
  [2617] = "Enchant Bracer - Superior Healing:27911",
  [2619] = "Enchant Cloak - Greater Fire Resistance:25081",  -- +15 Fire Resistance
--  [2620] = "0", -- +15 Nature Resistance
  [2621] = "Enchant Cloak - Subtlety:25084",
  [2622] = "Enchant Cloak - Dodge:25086",

  [2647] = "Enchant Bracer - Brawn:27899",
  [2648] = "Enchant Bracer - Major Defense:27906", -- +12 Defense Rating
  [2649] = "Enchant Boots - Fortitude:27950", -- +12 Stamina
  [2650] = "Enchant Bracer - Spellpower:27917",  --+15 Spell Damage

  [2653] = "Enchant Shield - Tough Shield:27944", --+18 Block Value
  [2654] = "Enchant Shield - Intellect:27945", -- +12 Intellect
  [2656] = "Enchant Boots - Vitality:27948",
  [2657] = "Enchant Boots - Dexterity:27951",
  [2658] = "Enchant Boots - Surefooted:27954",
  [2659] = "Enchant Chest - Exceptional Health:27957", -- +150 Health
  [2660] = "Enchant Chest - Exceptional Mana:27958", -- +150 Mana
  [2661] = "Enchant Chest - Exceptional Stats:27960", -- +6 All Stats
  [2662] = "Enchant Cloak - Major Armor:27961",
  [2665] = "Enchant Weapon - Major Spirit:27964", -- +35 Spirit (NYI)
  [2666] = "Enchant Weapon - Major Intellect:27968",
  [2667] = "Enchant 2H Weapon - Savagery:27971",
  [2668] = "Enchant Weapon - Potency:27972",
  [2669] = "Enchant Weapon - Major Spellpower:27975",
  [2670] = "Enchant 2H Weapon - Major Agility:27977",
  [2671] = "Enchant Weapon - Sunfire:27981",
  [2672] = "Enchant Weapon - Soulfrost:27982",
  [2673] = "Enchant Weapon - Mongoose:27984", -- Mongoose
  [2674] = "Enchant Weapon - Spellsurge:28003",
  [2675] = "Enchant Weapon - Battlemaster:28004",

  [2679] = "Enchant Bracer - Restore Mana Prime:27913",

  [2681] = 22635, --Savage Guard
  [2682] = 22636, --Ice Guard
  [2683] = 22638, --Shadow Guard
  [2684] = 23122, --Consecrated Sharpening Stone
  [2685] = 23123, --Blessed Wizard Oil

  [2712] = 23528,  --Fel Sharpening Stone
  [2713] = 23529, --Adamantite Sharpening Stone
  [2714] = 23530, --Felsteel Shield Spike
  [2715] = 23547, --Resilience of the Scourge
  [2716] = 23549, --Fortitude of the Scourge
  [2717] = 23548, --Might of the Scourge
  [2718] = 23559, --Lesser Rune of Warding
  [2719] = 23575, --Lesser Rune of Shielding
  [2720] = 23576, --Greater Rune of Shielding
  [2721] = 23545, --Power of the Scourge
  [2722] = 23764, --Adamantite Scope
  [2723] = 23765, --Khorium Scope
  [2724] = 23766, --Stabilized Eternium Scope

  [2745] = 24275, --Silver Spellthread
  [2746] = 24276, --Golden Spellthread
  [2747] = 24273, --Mystic Spellthread
  [2748] = 24274, --Runic Spellthread

  [2791] = 25521, --Greater Rune of Warding
  [2792] = 25650, --Knothide Armor Kit
  [2793] = 25651, --Vindicator's Armor Kit
  [2794] = 25652, --Magister's Armor Kit
  [2795] = 25679, --Comfortable Insoles
  [2836] = 25652, --Magister's Armor Kit??
  [2841] = 34330, --+10 Stamina (Heavy Knothide Armor Kit)
  [2928] = "Enchant Ring - Spellpower:27924",  --+12 Spell Damage
  [2929] = "Enchant Ring - Striking:27920",  --+2 Weapon Damage
  [2930] = "Enchant Ring - Healing Power:27926",  --+20 Healing
  [2931] = "Enchant Ring - Stats:27927",  --+20 Healing

  [2933] = "Enchant Chest - Major Resilience:33992",
  [2934] = "Enchant Gloves - Blasting:33993",
  [2937] = "Enchant Gloves - Major Spellpower:33997",
  [2938] = "Enchant Cloak - Spell Penetration:34003",
  [2939] = "Enchant Boots - Cat's Swiftness:34007",
  [2940] = "Enchant Boots - Boar's Speed:34008",
  [2942] = 28290, --Smooth Golden Draenite
  [2954] = 28420, --Fel Weightstone
  [2955] = 28421, --Adamantite Weightstone
  [2977] = 28882, --Inscription of Warding   (Aldor)
  [2978] = 28889, --Greater Inscription of Warding   (Aldor)
  [2979] = 28878, --Inscription of Faith   (Aldor)
  [2980] = 28887, --Greater Inscription of Faith   (Aldor)
  [2981] = 28881, --Inscription of Discipline   (Aldor)
  [2982] = 28886, --Greater Inscription of Discipline   (Aldor)
  [2983] = 28885, --Inscription of Vengeance   (Aldor)
  [2986] = 28888, --Greater Inscription of Vengeance
  [2990] = 28908, --Inscription of the Knight
  [2991] = 28911, --Greater Inscription of the Knight
  [2992] = 28904, --Inscription of the Oracle
  [2993] = 28912, --Greater Inscription of the Oracle
  [2994] = 28903, --Inscription of the Orb
  [2995] = 28909, --Greater Inscription of the Orb
  [2996] = 28907, --Inscription of the Blade
  [2997] = 28910, --Greater Inscription of the Blade
  [2998] = 29187, --Inscription of Endurance
  [2999] = 29186, --Glyph of the Defender
  [3001] = 29189, --Glyph of Renewal
  [3002] = 29191, --Glyph of Power
  [3003] = 29192, --Glyph of Ferocity
  [3005] = 29194, --Glyph of Nature Warding
  [3006] = 29195, --Glyph of Arcane Warding
  [3007] = 29196, --Glyph of Fire Warding
  [3008] = 29198, --Glyph of Frost Warding
  [3009] = 29199, --Glyph of Shadow Warding
  [3010] = 29533, --Cobrahide Leg Armor
  [3011] = 29534, --Clefthide Leg Armor
  [3012] = 29535, --Nethercobra Leg Armor
  [3013] = 29536, --Nethercleft Leg Armor

  [3096] = 30846, --Glyph of the Outcast

  [3150] = "Enchant Chest - Restore Mana Prime:33991", --New enchant id?

  [3222] = "Enchant Weapon - Greater Agility:42620", --+20 Agility
  [3223] = 33285,	--Adamantite Weapon Chain

  [3225] = "Enchant Weapon - Executioner:42974",	--Executioner

  [3260] = 34207,	--Glove Reinforcements

  [5000] = 0
}

function JewelTips.JewelLink(JewelID)
  local index = tonumber(JewelID)
  if not index then return nil end

  local item = JewelTips.Jewels[index]

  if item and item ~= 0 then
    if type(item) == "number" then
      return select(2, GetItemInfo(item)) or item
    else
      return strgsub(item, "(.+):(%d+)", "|cffffd000|Henchant:%2|h[%1]|h|r")
    end
  else
    return -1 * index --index is negated to show that the number is the original enchantID
  end
end

function JewelTips.JewelColor(itemLink)
  local subtype = select(7,GetItemInfo( itemLink ))
  local colorString

  if subtype == BLUE_GEM then
    colorString = "0000ff"
  elseif subtype == RED_GEM then
    colorString = "ff0000"
  elseif subtype == YELLOW_GEM then
    colorString = "ffff00"
  elseif subtype == "Purple" then
    colorString = "8000ff"
  elseif subtype == "Orange" then
    colorString = "ff8040"
  elseif subtype == "Green" then
    colorString = "00ff00"
  elseif subtype == "Meta" then
    colorString = "aaaaaa"
  else
    colorString = "ffffff"
  end

  return " (|cff"..colorString..subtype.."|r)"
end

local enchant, gem1, gem2, gem3, gem1num, gem2num, gem3num
local irefenchant, irefgem1, irefgem2, irefgem3, icon

local enchantButton = CreateFrame("Button",nil,ItemRefTooltip)
enchantButton:SetWidth(JewelTips.BUTTON_SIZE)
enchantButton:SetHeight(JewelTips.BUTTON_SIZE)
enchantButton:SetScript("OnClick",function() 
  if IsShiftKeyDown() then
    if WIM_EditBoxInFocus then
      WIM_EditBoxInFocus:Insert(irefenchant);
    elseif ChatFrameEditBox:IsVisible() then
      ChatFrameEditBox:Insert(irefenchant);
    end
  end
end)
enchantButton:SetScript("OnEnter",function()
  local irefenchantnum = tonumber(irefenchant)
  if irefenchantnum and irefenchantnum < 0 then return end

  GameTooltip:SetOwner(this, JewelTips.TOOLTIP_ANCHOR, 0, JewelTips.BUTTON_SIZE+2)

  if irefenchantnum then
    
    if select(2,GameTooltip:GetItem()) ~= irefenchant then
      GameTooltip:SetHyperlink("item:"..irefenchant)
    end
    local _, link, _, _, _, _, _, _, _, icon = GetItemInfo(irefenchant)
    if link then
      irefenchant = link
      enchantButton:SetNormalTexture(icon)
    end

  else
    if select(2,GameTooltip:GetItem()) ~= irefenchant then
      GameTooltip:SetHyperlink(irefenchant)
    end
  end
  GameTooltip:Show()
end)
enchantButton:SetScript("OnLeave",function() 
  GameTooltip:Hide()
end)

local gem1Button = CreateFrame("Button",nil,ItemRefTooltip)
gem1Button:SetWidth(JewelTips.BUTTON_SIZE)
gem1Button:SetHeight(JewelTips.BUTTON_SIZE)
gem1Button:SetScript("OnClick",function() 
  if IsShiftKeyDown() then
    if WIM_EditBoxInFocus then
      WIM_EditBoxInFocus:Insert(irefgem1);
    elseif ChatFrameEditBox:IsVisible() then
      ChatFrameEditBox:Insert(irefgem1);
    end
  end
end)
gem1Button:SetScript("OnEnter",function() 
  GameTooltip:SetOwner(this, JewelTips.TOOLTIP_ANCHOR, 0, JewelTips.BUTTON_SIZE+2)
  if tonumber(irefgem1) then
    irefgem1 = select(2,GetItemGem( select(2,ItemRefTooltip:GetItem()) ,1))
    gem1Button:SetNormalTexture( select(10, GetItemInfo(irefgem1)) )
  end
  if select(2,GameTooltip:GetItem()) ~= irefgem1 then
    GameTooltip:SetHyperlink(irefgem1)
  end
  GameTooltip:Show()
end)
gem1Button:SetScript("OnLeave",function() 
  GameTooltip:Hide()
end)

local gem2Button = CreateFrame("Button",nil,ItemRefTooltip)
gem2Button:SetWidth(JewelTips.BUTTON_SIZE)
gem2Button:SetHeight(JewelTips.BUTTON_SIZE)
gem2Button:SetScript("OnClick",function() 
  if IsShiftKeyDown() then
    if WIM_EditBoxInFocus then
      WIM_EditBoxInFocus:Insert(irefgem2);
    elseif ChatFrameEditBox:IsVisible() then
      ChatFrameEditBox:Insert(irefgem2);
    end
  end
end)
gem2Button:SetScript("OnEnter",function() 
  GameTooltip:SetOwner(this, JewelTips.TOOLTIP_ANCHOR, 0, JewelTips.BUTTON_SIZE+2)
  if tonumber(irefgem2) then
    irefgem2 = select(2,GetItemGem( select(2,ItemRefTooltip:GetItem()) ,2))
    gem2Button:SetNormalTexture( select(10, GetItemInfo(irefgem2)) )
  end
  if select(2,GameTooltip:GetItem()) ~= irefgem2 then
    GameTooltip:SetHyperlink(irefgem2)
  end
  GameTooltip:Show()
end)
gem2Button:SetScript("OnLeave",function() 
  GameTooltip:Hide()
end)

local gem3Button = CreateFrame("Button",nil,ItemRefTooltip)
gem3Button:SetWidth(JewelTips.BUTTON_SIZE)
gem3Button:SetHeight(JewelTips.BUTTON_SIZE)
gem3Button:SetScript("OnClick",function() 
  if IsShiftKeyDown() then
    if WIM_EditBoxInFocus then
      WIM_EditBoxInFocus:Insert(irefgem3);
    elseif ChatFrameEditBox:IsVisible() then
      ChatFrameEditBox:Insert(irefgem3);
    end
  end
end)
gem3Button:SetScript("OnEnter",function() 
  GameTooltip:SetOwner(this, JewelTips.TOOLTIP_ANCHOR, 0, JewelTips.BUTTON_SIZE+2)
  if tonumber(irefgem3) then
    irefgem3 = select(2,GetItemGem( select(2,ItemRefTooltip:GetItem()) ,3))
    gem3Button:SetNormalTexture( select(10, GetItemInfo(irefgem3)) )
  end
  if select(2,GameTooltip:GetItem()) ~= irefgem3 then
    GameTooltip:SetHyperlink(irefgem3)
  end
  GameTooltip:Show()
end)
gem3Button:SetScript("OnLeave",function() 
  GameTooltip:Hide()
end)

enchantButton:SetPoint("TOPRIGHT", ItemRefTooltip, "TOPLEFT", 0, -40)
gem1Button:SetPoint("TOPRIGHT", ItemRefTooltip, "TOPLEFT", 0, -70)
gem2Button:SetPoint("TOPRIGHT", ItemRefTooltip, "TOPLEFT", 0, -100)
gem3Button:SetPoint("TOPRIGHT", ItemRefTooltip, "TOPLEFT", 0, -130)

function JewelTips.ClearButtons(link)
  enchantButton:Hide()
  gem1Button:Hide()
  gem2Button:Hide()
  gem3Button:Hide()
end

JewelTips.ClearButtons()  --Initially Hide all buttons

--Main Routine--------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
local lastlink = "None"
function JewelTips.Main(tooltip, name, link)

  --Check if the tooltip is one of our Jewel tooltips
  if tooltip:IsOwned(enchantButton) or
     tooltip:IsOwned(gem1Button) or
     tooltip:IsOwned(gem2Button) or
     tooltip:IsOwned(gem3Button)
  then
    return
  end
  
  --For some tooltips, this Main function will be called continuously. This code keeps us from doing unnecessary work after the first time.
  if link ~= lastlink then  --Reuse data from the last call since the tooltip link is the same
    enchant, gem1num, gem2num, gem3num = string.match(link, "item:%d+:(%d+):(%d+):(%d+):(%d+):")

    if enchant == "0" then
      enchant = nil
    else
      enchant = JewelTips.JewelLink(enchant)
    end

    if gem1num == "0" then
      gem1 = nil
    else
      gem1 = select(2,GetItemGem(link,1)) or gem1num
      gem1texture = select(10,GetItemInfo(gem1))
    end
    if gem2num == "0" then
      gem2 = nil
    else
      gem2 = select(2,GetItemGem(link,2)) or gem2num
      gem2texture = select(10,GetItemInfo(gem2))
    end
    if gem3num == "0" then
      gem3 = nil
    else
      gem3 = select(2,GetItemGem(link,3)) or gem3num
      gem3texture = select(10,GetItemInfo(gem3))
    end
  end

  --Add tooltip lines
  if enchant then
    if type(enchant) == "number" then
      if enchant < 0 then
        tooltip:AddLine( "[Unknown Enchant: " .. (-1 * enchant) .. "] (|cffffffffEnchant|r)" )
      else
        tooltip:AddLine( "[Unsafe Link: " .. enchant .. "] (|cffffffffEnchant|r)" )
        lastlink = "None"
      end
      tooltip:AddTexture(JewelTips.QUESTIONMARK_ICON)
    else
      tooltip:AddLine( enchant .. " (|cffffffffEnchant|r)")
      if strmatch( enchant, "Henchant:" ) then
        tooltip:AddTexture("Interface\\Icons\\Spell_Holy_GreaterHeal")
      else
        tooltip:AddTexture(select(10,GetItemInfo(enchant)) or JewelTips.QUESTIONMARK_ICON)
      end
    end
  end
  if gem1 then
    if tonumber(gem1) then
      lastlink = "None"
    else
      tooltip:AddLine( gem1 .. JewelTips.JewelColor(gem1))
      tooltip:AddTexture(gem1texture)
    end
  end
  if gem2 then
    if tonumber(gem2) then
      lastlink = "None"
    else
      tooltip:AddLine( gem2 .. JewelTips.JewelColor(gem2))
      tooltip:AddTexture(gem2texture)
    end
  end
  if gem3 then
    if tonumber(gem3) then
      lastlink = "None"
    else
      tooltip:AddLine( gem3 .. JewelTips.JewelColor(gem3))
      tooltip:AddTexture(gem3texture)
    end
  end

  tooltip:Show()

  if tooltip == ItemRefTooltip then --Set up the gem icons
    irefenchant = enchant
    irefgem1 = gem1
    irefgem2 = gem2
    irefgem3 = gem3

    if irefenchant then
      if type(irefenchant) == "number" then
        enchantButton:SetNormalTexture(JewelTips.QUESTIONMARK_ICON)
      else
        icon = select( 10, GetItemInfo( irefenchant ) )
        enchantButton:SetNormalTexture(icon or "Interface\\Icons\\Spell_Holy_GreaterHeal")
      end
      enchantButton:Show()
    else
      enchantButton:Hide()
    end
    if irefgem1 then
      if tonumber(irefgem1) then
        gem1Button:SetNormalTexture(JewelTips.QUESTIONMARK_ICON)
      else
        icon = select( 10, GetItemInfo( irefgem1 ) )
        gem1Button:SetNormalTexture(icon)
      end
      gem1Button:Show()
    else
      gem1Button:Hide()
    end
    if irefgem2 then
      if tonumber(irefgem2) then
        gem2Button:SetNormalTexture(JewelTips.QUESTIONMARK_ICON)
      else
        icon = select( 10, GetItemInfo( irefgem2 ) )
        gem2Button:SetNormalTexture(icon)
      end
      gem2Button:Show()
    else
      gem2Button:Hide()
    end
    if irefgem3 then
      if tonumber(irefgem3) then
        gem3Button:SetNormalTexture(JewelTips.QUESTIONMARK_ICON)
      else
        icon = select( 10, GetItemInfo( irefgem3 ) )
        gem3Button:SetNormalTexture(icon)
      end
      gem3Button:Show()
    else
      gem3Button:Hide()
    end
  end
end

--Clear the side buttons when a spell is set for the ItemRefTooltip
local orig1 = ItemRefTooltip:GetScript("OnTooltipSetSpell")
ItemRefTooltip:SetScript("OnTooltipSetSpell", function(...)
	JewelTips.ClearButtons()

	if orig1 then return orig1(...) end
end)

